#include <iostream>
#include <math.h>
#include "konzola.h" // Jen Windows

using namespace std;
 
const int realne{ 0 }, komplexni{ 1 }, chybne_zadani{ 3 };

int res_q_rovnici(double koef[], double x[])
{
	if (koef[0] == 0)
	{
		return chybne_zadani;
	}
	double d = koef[1] * koef[1] - 4 * koef[0] * koef[2];
	if (d >= 0)
	{
		x[0] = (-koef[1] + sqrt(d)) / (2 * koef[0]);
		x[1] = (-koef[1] - sqrt(d)) / (2 * koef[0]);
		return realne;
	}
	else
	{
		x[0] = -koef[1] / (2 * koef[0]);
		x[1] = sqrt(-d) / (2 * koef[0]);
		return komplexni;
	}
}

void vypis_reseni(int priznak, double koef[], double koreny[])
{
	cout << "een kvadratick rovnice "
		<< koef[0] << "x^2 + " << koef[1] << "x + " << koef[2] << " = 0" << endl;
	switch (priznak)
	{
	case realne:
		cout << "Reln koeny: ";
		cout << "x1 = " << koreny[0] << ", x2 = " << koreny[1];
		break;
	case komplexni:
		cout << "Komplexn sdruen koeny: ";
		cout << "x1, x2 = " << koreny[0] << " \xB1 i." << koreny[1];
		break;
	case chybne_zadani:
		cout << "Zadn nepedstavuje kvadratickou rovnici";
	}
	cout << endl;
}

int main()
{
	nastav_konzolu_pro_cp1250();  // jen Windows
	double koreny[2];
	double koeficienty1[3]{ 1,2,1 };
	int priznak = res_q_rovnici(koeficienty1, koreny);
	vypis_reseni(priznak, koeficienty1, koreny);
	double koeficienty2[3]{ 1,0,1 };
	priznak = res_q_rovnici(koeficienty2, koreny);
	vypis_reseni(priznak, koeficienty2, koreny);
	double koeficienty3[3]{ 0,1,1 };
	priznak = res_q_rovnici(koeficienty3, koreny);
	vypis_reseni(priznak, koeficienty3, koreny);
}