#include <iostream>
#include <iomanip>
#include <string>
#include <math.h>
#include <algorithm>

#include "funkce.h"
using namespace std;

static int pocet_stupnu = 20;
static char symbol = '*';

void graf(mat_funkce f, zobr_funkce zobraz, double od, double po, int kolik, string jmeno)
{
	double krok = (po - od) / (kolik - 1);
	double *X = new double[kolik] {};
	double *Y = new double[kolik] {};
	for (int i = 0; i < kolik; i++)
	{
		X[i] = od + i*krok;
		Y[i] = f(X[i]);
	}
	zobraz(X, Y, kolik, jmeno);
	delete[] X;
	delete[] Y;
}

void zahlavi(string jmeno)
{
	cout << "Tabulka funkce " << jmeno << endl
		<< "------------------" << endl
		<< "x            " << jmeno
		<< "(x)" << endl
		<< "------------------" << endl;
}

void tabelace(double *x, double *y, int kolik, string jmeno)
{
	zahlavi(jmeno);
	cout << fixed << setprecision(2);
	for (int i = 0; i < kolik; i++)
	{
		cout << x[i] << "         " << y[i] << endl;
	}
}

void diagram(double *x, double *y, int kolik, string jmeno)
{
	double max = *max_element(y, y + kolik);
	double krok_y = max / pocet_stupnu;
	cout << "Diagram funkce " << jmeno << endl
	     << "--------------------" << endl << endl;
	cout << fixed << setprecision(2);
	for (int k = 0; k < kolik; k++)
	{
	    cout << x[k] << " ";
		int j = round(y[k] / krok_y);
		cout << (char)((j == 0) ? symbol : '|' );
		for (int i = 1; i <= pocet_stupnu; i++)
		{
			char znak = (i == j) ? symbol : ' ';
			cout << znak;
		}
		cout << endl;
	}
}

void nastav_diagram(char symbol, int pocet_stupnu)
{
	::symbol = symbol;
	::pocet_stupnu = pocet_stupnu;
}
