#include <iostream>
#include "vektor.h"
using namespace std;


vektor::vektor(int n)
	: delka(n), pole(new double[n] {})
{
	pocet++;
}

int vektor::pocet = 0;

vektor::vektor(initializer_list<double> il)
	: vektor(il.size())
{
	int i = 0;
	for (double x : il)
	{
		pole[i++] = x;
	}
}

vektor::vektor()
	: delka(0), pole(nullptr)
{
	pocet++;
}

vektor::vektor(const vektor & w)
:vektor(w.delka)
{
	for (int i = 0; i < delka; i++)
	{
		pole[i] = w.pole[i];
	}
}

vektor::~vektor()
{
	delete[] pole;
	pocet--;
}

vektor & vektor::operator=(vektor & v)
{
	if (v.delka != delka)
	{
		delka = v.delka;
		delete[] pole;
		pole = new double[delka];
	}
	for (int i = 0; i < delka; i++)
	{
		pole[i] = v.pole[i];
	}
	return *this;
}

void vektor::nastav(int index, double hodnota)
{
	pole[index] = hodnota;
}

void vektor::vypis()
{
	for (int i = 0; i < delka; i++)
	{
		cout << pole[i] << " ";
	}
	cout << endl;
}

int vektor::pocet_instanci()
{
	return pocet;
}