#include <iostream>
#include <fstream>
#include <iomanip>
#include <string> 
#include <math.h>
#include <stdexcept>

using namespace std;

using funkce = double(*)(double);

void kontrola(funkce f, double od, double po, int kolik)
{
	if (!f)
	{
		throw invalid_argument("Przdn ukazatel na tabelovanou funkci");
	}
	if (kolik <= 0) 
	{
		throw invalid_argument("Nekladn poet poadovanch hodnot");
	}
	if ((kolik == 1) && (od != po))
	{
		throw invalid_argument("Poadovna jedin hodnota v intervalu nenulov dlky");
	}
}

void zahlavi(string jmeno, int sirka_x, int sirka_f)
{
	int pocet_pomlcek = sirka_x + 10 + sirka_f;
	cout << "Tabulka funkce " << jmeno << endl
		<< string(pocet_pomlcek, '-') << endl << setw(sirka_x)
		<< "x" << string(5 + sirka_x, ' ') << setw(sirka_f) << jmeno << endl
		<< string(pocet_pomlcek, '-') << endl;
}


void tabulka(funkce f, string jmeno, double od, double po, 
	         int kolik, int presnost_x, int presnost_f, 
			 int sirka_x, int sirka_f)
{
	kontrola(f, od, po, kolik);
	double krok = kolik == 1 ? 0 : (po - od) / (kolik - 1);
	zahlavi(jmeno, sirka_x, sirka_f);
	cout << fixed;
	for (int i = 0; i < kolik; i++)
	{
		double x = od + i*krok;
		cout << setprecision(presnost_x) << setw(sirka_x) << x << "         "
			<< setprecision(presnost_f) << setw(sirka_f) << f(x) << endl;
	}
}

int main()
{
	try
	{
		tabulka([](double x)->double {return x*x; }, "x^2", 998, 1008, 11, 0, 0, 4, 8);
		cout << "**************" << endl;
		tabulka(sin, "sin(x)", 0, 1, 11, 2, 5, 4, 7);
	}
	catch (invalid_argument e)
	{
		cerr << e.what() << endl;
	}
}

