#define  _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stdio.h>
#include <stdexcept>
#include <string.h>

using namespace std;

typedef double (*funkce)(double);

struct popis_funkce
{
	funkce f;
	char *jmeno;
};

struct popis_tabulky
{
	double od, po;
	int kolik;
};

struct popis_vystupu
{
	int sirka_x, sirka_f, presnost_x, presnost_f;
	FILE *proud;
	char *jmeno;
};

void kontrola(popis_funkce fun, popis_tabulky tab, popis_vystupu vyst)
{
	if (!vyst.proud)
	{
		throw runtime_error(string("Nepodailo se otevt soubor ") + vyst.jmeno);
	}
	if (!fun.f)
	{
		throw invalid_argument("Przdn ukazatel na tabelovanou funkci");
	}
	if (tab.kolik <= 0)
	{
		throw invalid_argument("Nekladn poet poadovanch hodnot");
	}
	if ((tab.kolik == 1) && (tab.od != tab.po))
	{
		throw invalid_argument("Poadovna jedin hodnota v intervalu nenulov dlky");
	}
}

void zahlavi(popis_funkce fun, popis_tabulky tab, popis_vystupu vyst)
{
	const int delka = 50;
	char pomlcky[delka], mezery[delka];
	memset(pomlcky, '-', delka - 1);
	pomlcky[delka - 1] = 0;
	int pocet_pomlcek = vyst.sirka_x + 11 + vyst.sirka_f;
	int pocet_mezer = vyst.sirka_x + vyst.sirka_f;
	fprintf(vyst.proud, "Tabulka funkce %s \n", fun.jmeno);
	fprintf(vyst.proud, "%.*s\n", pocet_pomlcek, pomlcky);
	fprintf(vyst.proud, "%*s%*c%s(x)\n", vyst.sirka_x, "x", pocet_mezer, ' ', fun.jmeno);
	fprintf(vyst.proud, "%.*s\n", pocet_pomlcek, pomlcky);
}

void tabulka(popis_funkce fun, popis_tabulky tab, popis_vystupu vyst)
{
	kontrola(fun, tab, vyst);
	double krok = tab.kolik == 1 ? 0 : (tab.po - tab.od) / (tab.kolik - 1);
	zahlavi(fun, tab, vyst);
	for (int i = 0; i < tab.kolik; i++)
	{
		double x = tab.od + i*krok;
		fprintf(vyst.proud, "%*.*f           %*.*f\n", vyst.sirka_x, vyst.presnost_x, x, vyst.sirka_f, vyst.presnost_f, fun.f(x));
	}
}

int main()
{
	try
	{
		FILE *proud = fopen("data.txt", "w");
		popis_funkce fun{ sin, "sin" };
		popis_tabulky tab{ 0,1,11 };
		popis_vystupu vyst{ 4,7,2,5,proud };
		tabulka(fun, tab, vyst);
		fprintf(proud , "\n**************\n\n");
		popis_funkce f1{ [](double x)->double {return x*x; },"x^2" };
		popis_tabulky tab1{ 998,1008,11 };
		popis_vystupu vyst1{ 4,7,0,0,proud };
		tabulka(f1, tab1, vyst1);
	}
	catch (exception& e)
	{
		fprintf(stderr, "%s", e.what());
	}
}

